package com.io.yutian.aulib.command;

import com.io.yutian.aulib.command.handler.CommandHandler;
import com.io.yutian.aulib.command.list.CommandHelp;
import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;
import org.jetbrains.annotations.NotNull;

import java.util.ArrayList;
import java.util.List;

public class SimpleCommandManager implements ICommandManager {

    private final String name;

    @NotNull
    private List<ICommand> commands;

    public SimpleCommandManager(String name) {
        this(name, new ArrayList<>());
    }

    public SimpleCommandManager(String name, @NotNull List<ICommand> commands) {
        this.name = name;
        this.commands = commands;
        register(new CommandHelp(this));
    }

    public void register(@NotNull ICommand command) {
        if (command == null) {
            return;
        }
        commands.add(command);
    }

    public void registerBukkitCommand(@NotNull Plugin plugin, String commandName) {
        Bukkit.getPluginCommand(commandName).setExecutor(new CommandHandler(plugin, this));
    }

    @NotNull
    @Override
    public String getName() {
        return name;
    }

    @NotNull
    @Override
    public List<ICommand> getCommands() {
        return commands;
    }

}
