package com.io.yutian.aulib.nbt;

public class NBTDouble extends NBTNumber {

    public static byte TYPE_ID = 6;

    private double value;

    public NBTDouble(double value) {
        this.value = value;
    }

    public NBTDouble() {
    }

    @Override
    public Object getValue() {
        return value;
    }

    @Override
    public byte getTypeId() {
        return TYPE_ID;
    }

    @Override
    public long getLong() {
        return (long) this.value;
    }

    @Override
    public int getInt() {
        return floor(this.value);
    }

    @Override
    public short getShort() {
        return (short)(floor(this.value) & 0xFFFF);
    }

    @Override
    public byte getByte() {
        return (byte)(floor(this.value) & 0xFF);
    }

    @Override
    public double getDouble() {
        return this.value;
    }

    @Override
    public float getFloat() {
        return (float) this.value;
    }

    @Override
    public String toString() {
        return "NBTDouble{" +
                "value=" + value +
                '}';
    }
}
